package tech.nevets.jaml.util;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import org.apache.commons.io.FileUtils;
import tech.nevets.jaml.JAML;

import java.io.File;
import java.io.IOException;
import java.net.URL;

public class VersionFetcher {

    public static JsonObject getList() throws IOException {
        URL versionManifestUrl = new URL("https://launchermeta.mojang.com/mc/game/version_manifest.json");
        FileUtils.copyURLToFile(versionManifestUrl, new File(JAML.path + "\\data\\version.json"));

        File versionManifestFile = new File(JAML.path + "\\data\\version.json");

        return new Gson().fromJson(FileUtils.readFileToString(versionManifestFile), JsonObject.class);
    }

    public static String getLatestVersion(String branch) throws IOException {
        JsonObject versionManifestJson = getList();
        JsonObject latestJsonObject = versionManifestJson.get("latest").getAsJsonObject();

        return latestJsonObject.get(branch).getAsString();
    }
}
